;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; THIS TEMPLATE FILE IS USED BY THE Multi Photo Quotes BUILDER tool
;
; ATTENTION: DO NOT MODIFY THIS FILE -- not only is it used for all build events
;  but it will be *OVERWRITTEN* when you upgrage Multi Photo Quotes.
;
; IF you wish to customize the template, make a new copy of this file with a different name,
;  and use your custom template when you build.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;








;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Include the variable defines for the screensaver (and mediapack if building that)
;
#include <InstallDefs_ScreenSaver.def>
#ifdef mediapack
	#include <InstallDefs_MediaPack.def>
#endif



; Decide on the screensaver install idname (usually SSIDNAME=SSFILENAME)
;  this includes a kludge fixup for the exception to the rule of no spaces
;  which i violated unthinkingly for MPQ
;
#ifndef SSIDNAME
	#if SSNAME == "MultiPhotoQuotes"
		#define public SSIDNAME "Multi Photo Quotes"
	#else
		#define public SSIDNAME SSNAME
	#endif
#endif



; this just points back to the installed Multi Photo Quotes directory
;  where the exe and other files are found we check its existence first
;  so user can override it in the .def file in case they want to build
;  in a deeper dir
;
#ifndef MPQEXEDIR
	#define public MPQEXEDIR "..\.."
#endif
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;








;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; OKAY NOW WE BUILD THE SCREENSAVER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


; These items are OPTIONAL and we shouldnt link to them unless they are found
#define public filenamechm = curdir + "\InstallFiles\" + SSNAME + ".chm"
#define public filenameurl = curdir + "\InstallFiles\Visit Homepage.url.url"
#define public filenamedcu = curdir + "\InstallFiles\" + SSNAME + ".dcupdate"




[Files]
; The first set of files are copied from main Multi Photo Quotes directory and just renamed when appropriate
Source: {#MPQEXEDIR}\CloseApp2.dll; DestDir: {app}; Flags: ignoreversion
Source: {#MPQEXEDIR}\dwlGina3.dll; DestDir: {app}; Flags: ignoreversion
Source: {#MPQEXEDIR}\MultiPhotoQuotes.exe; DestDir: {app}; DestName: {#SSNAME}.exe; Flags: overwritereadonly ignoreversion uninsremovereadonly replacesameversion
Source: {#MPQEXEDIR}\MultiPhotoQuotes.exe; Destdir: {win}; DestName: ss{#SSNAME}.scr; Flags: overwritereadonly ignoreversion uninsremovereadonly replacesameversion
Source: {#curdir}\InstallFiles\*.*; DestDir: {app}; Flags: ignoreversion recursesubdirs



[Icons]
; Icons (shortcuts) for all installs
Name: {group}\{#SSLONGNAME} - Test in Window; Filename: {app}\{#SSNAME}.exe; Parameters: """/window"""; WorkingDir: {app}; IconFilename: {app}\{#SSNAME}.exe; IconIndex: 0
Name: {group}\{#SSLONGNAME} - Launch Screensaver; Filename: {win}\ss{#SSNAME}.scr; WorkingDir: {win}; IconFilename: {app}\{#SSNAME}.exe; IconIndex: 0
Name: {group}\{#SSLONGNAME} - Configure Screensaver; Filename: {app}\{#SSNAME}.exe; Parameters: /c; WorkingDir: {win}; IconFilename: {app}\{#SSNAME}.exe; IconIndex: 0
Name: {group}\Uninstall {#SSLONGNAME}; Filename: {app}\unins000.exe; WorkingDir: {app}



#if FileExists(filenamechm)
	Name: {group}\{#SSLONGNAME} Help; Filename: {app}\{#SSNAME}.chm; WorkingDir: {app}
#endif

#if FileExists(filenameurl)
	Name: {group}\{#SSLONGNAME} - Visit Homepage; Filename: {app}\Visit Homepage.url.url; WorkingDir: {app}
#endif

#if FileExists(filenamedcu)
	Name: {group}\{#SSLONGNAME} - Update Check; Filename: {app}\{#SSNAME}.exe; Parameters: /update; WorkingDir: {win}; IconFilename: {app}\{#SSNAME}.exe; IconIndex: 0
#endif



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




[Setup]
; grab previous install location for SS
UsePreviousAppDir=true
; basic default options
AllowNoIcons=true
ShowLanguageDialog=yes
MergeDuplicateFiles=false
AppendDefaultDirName=false
DisableFinishedPage=false

AppId={#SSIDNAME}
OutputBaseFilename={#SSNAME}Setup
AppCopyright={#SSCOMPANY}
VersionInfoCompany={#SSCOMPANY}
AppName={#SSLONGNAME}
AppVerName={#SSLONGNAME} {#SSVERSION}

DefaultGroupName={#SSLONGNAME}
DefaultDirName={pf}\{#SSNAME}
OutputDir={#curdir}




[UninstallDelete]



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





[Run]

#if FileExists(filenameurl)
	Filename: {app}\Visit Homepage.url.url; WorkingDir: {app}; Description: Visit {#SSLONGNAME}  Web Site; Flags: postinstall nowait shellexec unchecked
#endif

; Offer to open screensaver property dialog with new screensaver selected?
Filename: {sys}\rundll32.exe; Parameters: desk.cpl,InstallScreenSaver {win}\ss{#SSNAME}.scr; Description: "Make ""{#SSLONGNAME}"" your default screensaver and configure now"; Flags: postinstall nowait shellexec



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




[Code]



// initialize install path to parent app
function InitializeSetup(): Boolean;
begin
  Result := True;
end;



// from http://www.vincenzo.net/isxkb/index.php?title=Upgrades
function IsUpgrade(): Boolean;
var
   sPrevPath: String;
begin
  sPrevPath := '';
  if not RegQueryStringValue(HKLM, 'Software\Microsoft\Windows\CurrentVersion\Uninstall\{#emit SetupSetting("AppID")}_is1', 'UninstallString', sPrevpath) then
    RegQueryStringValue(HKCU, 'Software\Microsoft\Windows\CurrentVersion\Uninstall\{#emit SetupSetting("AppID")}_is1', 'UninstallString', sPrevpath);
  Result := (sPrevPath <> '');
end;


function ShouldSkipPage(PageID: Integer): Boolean;
begin
  Result := False;
  if IsUpgrade() then
  begin
		// we dont really have to skip these if user wants to change their mind.. but we do anyway to make things less confusing
    if PageID = wpSelectDir then Result := True;
    if PageID = wpSelectProgramGroup then Result := True;
  end;
end;


// from http://www.vincenzo.net/isxkb/index.php?title=Checking_application_prerequisites
function IsMyPrerequisiteInstalled(): Boolean;
begin
		Result := True;
end;




// ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


// FOR CLOSING ALREADY RUNNING EXE

//importing a custom DLL function
procedure CloseAnApp2(lpfname: String; timeout: Integer; forcekill: BOOL; silenterror:BOOL);
external 'CloseAnApp@{app}\CloseApp2.dll cdecl uninstallonly delayload';

procedure CloseAnApp(lpfname: String; timeout: Integer; forcekill: BOOL; silenterror:BOOL);
external 'CloseAnApp@files:CloseApp2.dll cdecl setuponly delayload';


function NextButtonClick(CurPage: Integer): Boolean;
begin
  Result := True;

  if not IsMyPrerequisiteInstalled() then begin
    Result := False;
    Exit;
  end;

  if CurPage = wpWelcome then begin
    CloseAnApp('{#SSNAME}.exe',5000,false,false);
    CloseAnApp('ss{#SSNAME}.scr',5000,false,false);
  end;

end;



procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin
  // Call our function just before the actual uninstall process begins
  if CurUninstallStep = usUninstall then
  begin
    CloseAnApp2('{#SSNAME}.exe',5000,false,false);
    CloseAnApp2('ss{#SSNAME}.scr',5000,false,false);
    // Now that we're finished with it, unload MyDll.dll from memory.
    // We have to do this so that the uninstaller will be able to remove the DLL and the {app} directory.
    UnloadDLL(ExpandConstant('{app}\CloseApp2.dll'));
  end;
end;





// ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





[Messages]
 WelcomeLabel2=This will install {#SSLONGNAME} on your computer.
